#include<iostream>
#include"DMatrix.h"
#include"DVector.h"
#include"SMatrix.h"
#include"SVector.h"
#include"MyBlas.h"
#include"MyLapack.h"
#include<cmath>
#include<stdlib.h>

using namespace std;

int main()
{
int ndim=3,lwork;
int info;

DVector V1,V2,V3,X,T;
DMatrix M1,M2,M3;

V1.allocate(ndim-1);
V2.allocate(ndim);
V3.allocate(ndim);
X.allocate(3);
double sum,*work;
M1.allocate(ndim-1,ndim);
M2.allocate(ndim,ndim);
M3.allocate(ndim,ndim);

int ipiv[3],ldx;

srand(1);


for(int i=0;i<ndim;i++) 
{ 
	V3(i)=(float)rand()/(double)RAND_MAX; 
	V2(i)=(float)rand()/(double)RAND_MAX;	
for(int j=0;j<ndim;j++) 
	{
	M3(j,i)=(float)rand()/(double)RAND_MAX;
	M2(j,i)=(float)rand()/(double)RAND_MAX;
	}
}


cout << M2 << endl;
M2.transpose();
cout << M2 << endl;

cout << M3 << endl;
M2=M3;
cout << M2 << endl;

M2=1.0;

M2=M2+M3;
cout << M2 << endl;

M1=1.0;

cout << V2 << endl;

dgemv_t(1.0,M1,V2,0.0,V1);

cout << V1 << " ciao a tutti " << endl;
	

/*
MY_DCOPY(ndim,V1,1,V3,1);
for(int i=0;i<ndim;i++) cout << V3[i] << "  ";
cout << endl;
cout << " DAXPY " << endl;
MY_DAXPY(ndim,2.0,V1,1,V3,1);
for(int i=0;i<ndim;i++) cout << V3[i] << "  ";
cout << endl;
cout << " DGEMV " << endl;
MY_DGEMV(CblasNoTrans,ndim,ndim,1.0,M1,ndim,V1,1,0.0,V3,1);
for(int i=0;i<ndim;i++) cout << V3[i] << "  ";
cout << endl;
cout << " DGEMM " << endl;
 MY_DGEMM(CblasNoTrans,CblasNoTrans,ndim,ndim,ndim,1.0
		 ,M1,ndim,M2,ndim,0.0,M3,ndim);
for(int i=0;i<ndim;i++)
{
	for(int j=0;j<ndim;j++)
		cout << M3[i*ndim+j] << "  ";
	cout << endl;
}*/

ldx=1;
lwork=ndim*ndim*ndim;
work= new double[lwork];

M3=0.0;

M3(0,0)=10;
M3(1,1)=10;
M3(2,2)=10;

info=DSYEV('n','u',M3,V2,work,lwork);



cout << V2 << endl;
/*
V1[0]=-1;
V1[1]=1;
V1[2]=0;

sum=MY_DASUM(3,V1,1);
cout << " sum = " << sum << endl;

cout << endl;*/
return(0);
}
